package com.mobvcasting.customcameraapp;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;

import android.app.Activity;
import android.content.ContentValues;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.PorterDuffXfermode;
import android.graphics.Bitmap.CompressFormat;
import android.hardware.Camera;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore.Images.Media;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageView;

public class CustomCamera extends Activity implements SurfaceHolder.Callback,
		Camera.PictureCallback, OnClickListener {

	SurfaceView cameraView;
	SurfaceHolder surfaceHolder;
	Camera camera;

	int currentPicture = 1;
	File imageFile1;
	File imageFile2;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		cameraView = (SurfaceView) this.findViewById(R.id.SurfaceView01);
		surfaceHolder = cameraView.getHolder();

		surfaceHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
		surfaceHolder.addCallback(this);

		cameraView.setClickable(true);
		cameraView.setOnClickListener(this);

	}

	public void surfaceChanged(SurfaceHolder holder, int format, int width,
			int height) {
		// TODO Auto-generated method stub

	}

	public void surfaceCreated(SurfaceHolder holder) {
		Log.v("CUSTOMCAMERA","Surface CREATED");
		camera = Camera.open();
		try {
			camera.setPreviewDisplay(surfaceHolder);
			camera.startPreview();
		} catch (IOException e) {
			camera.release();
			e.printStackTrace();
		}

	}

	public void surfaceDestroyed(SurfaceHolder holder) {
		Log.v("CUSTOMCAMERA","Surface Destroyed");
		camera.stopPreview();
		camera.release();
	}

	public void onPictureTaken(byte[] data, Camera camera) {

		try {
			File imageFile = File.createTempFile("doubleexposure", ".jpg");
			FileOutputStream imageFileOS = new FileOutputStream(imageFile);
			imageFileOS.write(data);
			imageFileOS.flush();
			imageFileOS.close();

			if (currentPicture == 1) {
				imageFile1 = imageFile;
				currentPicture++;
				camera.startPreview();
			} else if (currentPicture == 2) {
				imageFile2 = imageFile;
				cameraView.setVisibility(View.INVISIBLE);

				BitmapFactory.Options bmpFactoryOptions = new BitmapFactory.Options();
				bmpFactoryOptions.inJustDecodeBounds = true;
				Bitmap bmp = BitmapFactory.decodeFile(imageFile1.getPath(),
						bmpFactoryOptions);

				int heightRatio = (int) Math.ceil(bmpFactoryOptions.outHeight
						/ (float) getWindowManager().getDefaultDisplay()
								.getHeight());
				int widthRatio = (int) Math.ceil(bmpFactoryOptions.outWidth
						/ (float) getWindowManager().getDefaultDisplay()
								.getWidth());

				if (heightRatio > 1 && widthRatio > 1) {
					if (heightRatio > widthRatio) {
						bmpFactoryOptions.inSampleSize = heightRatio;
					} else {
						bmpFactoryOptions.inSampleSize = widthRatio;
					}
				}
				bmpFactoryOptions.inJustDecodeBounds = false;

				Bitmap picture1bmp = BitmapFactory.decodeFile(imageFile1
						.getPath(), bmpFactoryOptions);
				Bitmap picture2bmp = BitmapFactory.decodeFile(imageFile2
						.getPath(), bmpFactoryOptions);

				Bitmap drawingBmp = Bitmap.createBitmap(picture1bmp.getWidth(),
						picture1bmp.getHeight(), picture1bmp.getConfig());
				Canvas canvas = new Canvas(drawingBmp);
				Paint paint = new Paint();

				canvas.drawBitmap(picture1bmp, 0, 0, paint);
				
				paint.setXfermode(new PorterDuffXfermode(android.graphics.PorterDuff.Mode.MULTIPLY));
				canvas.drawBitmap(picture2bmp, 0, 0, paint);
				
				Paint newpaint = new Paint();
				newpaint.setColor(Color.GREEN);
				canvas.drawRect(100, 100, 150, 150, newpaint);
				
				ImageView iv = (ImageView) this.findViewById(R.id.DoubleExposureView);
				iv.setImageBitmap(drawingBmp);
				
				Uri imageFileUri = getContentResolver().insert(Media.EXTERNAL_CONTENT_URI, new ContentValues()); 
				try {
					OutputStream imageFileOSNew = getContentResolver().openOutputStream(imageFileUri); 
					drawingBmp.compress(CompressFormat.JPEG, 50, imageFileOSNew);
				
				} catch (FileNotFoundException e) {
				} catch (IOException e) {}				
				
				
			}

		} catch (Exception e) {
			e.printStackTrace();
		}

		/*
		 * Uri imageFileUri =
		 * getContentResolver().insert(android.provider.MediaStore
		 * .Images.Media.EXTERNAL_CONTENT_URI, new ContentValues()); try {
		 * OutputStream imageFileOS =
		 * getContentResolver().openOutputStream(imageFileUri);
		 * imageFileOS.write(data); imageFileOS.flush(); imageFileOS.close(); }
		 * catch (FileNotFoundException e) { } catch (IOException e) {}
		 */
	}

	public void onClick(View v) {
		camera.takePicture(null, null, null, this);
	}
}